//
// Copyright (C) 2011 Xavier MICHEL (xavier.michel.mx440@gmail.com)
//
// This software is provided as-is, without any express or implied warranty.
// In no event will the authors be held liable for any damages arising from the use of this software.
//
// Permission is granted to anyone to use this software for any purpose,
// including commercial applications, and to alter it and redistribute it freely,
// subject to the following restrictions:
//
// 1. The origin of this software must not be misrepresented;
//    you must not claim that you wrote the original software.
//    If you use this software in a product, an acknowledgment
//    in the product documentation would be appreciated but is not required.
//
// 2. Altered source versions must be plainly marked as such,
//    and must not be misrepresented as being the original software.
//
// 3. This notice may not be removed or altered from any source distribution.
//

#ifndef COMBOLOGLEVEL_HPP
#define COMBOLOGLEVEL_HPP

#include "Tools.hpp"
#include "CheckBoxList.hpp"

/*!
  \class ComboLogLevel
  \brief Une Combobox avec la liste des niveaux de log possibles. On peut sélectionner ces niveau à l'aide d'une checkbox
*/

class ComboLogLevel : public CheckBoxList {

Q_OBJECT

public:
    /*!
      \brief Les différents niveaux de logs qui apparaitront dans cette liste sont définis dans Tools.
    */
    ComboLogLevel();

    /*!
      \brief A-t-on selectionner le level donné ?
    */
    bool isChecked(LogLevel level);

};

#endif // COMBOLOGLEVEL_HPP
